<template>
  <div class="project-details-container container card">
    <div v-if="accessRequest.cancelled === 0">
      <div
        v-if="
          decodedToken &&
          accessRequest.should_be_revised === 1 &&
          accessRequest.user.email === decodedToken.email
        "
        class="revise-message"
      >
        <AlertTriangleIcon />
        The access manager has evaluated that you need to revise your access
        request. Please go to
        <a :href="`/access-request/${accessRequest.id}/revise`">
          <b><u>this page</u></b>
        </a>
        to revise or cancel your access request.
      </div>
    </div>

    <table striped hover>
      <tr>
        <td width="200px" class="property">Date Submitted</td>
        <td>
          {{
            new Date(accessRequest.created_at).toLocaleString('en-UK', {
              dateStyle: 'medium',
              timeStyle: 'short',
            })
          }}
        </td>
      </tr>
      <tr>
        <td class="property">Project Title</td>
        <td>{{ accessRequest.project_title }}</td>
      </tr>
      <tr>
        <td class="property">Acronym</td>
        <td>{{ accessRequest.project_acronym }}</td>
      </tr>
      <tr>
        <td class="property">Project Summary</td>
        <td>{{ accessRequest.project_summary }}</td>
      </tr>
      <tr>
        <td class="property">Project Objectives</td>
        <td>{{ accessRequest.project_objectives }}</td>
      </tr>
      <tr>
        <td class="property">Data Needed</td>
        <td>{{ accessRequest.data_needed }}</td>
      </tr>
      <tr>
        <td class="property">Applicant Name</td>
        <td>
          {{
            accessRequest.user.first_name + ' ' + accessRequest.user.last_name
          }}
        </td>
      </tr>
      <tr>
        <td class="property">Applicant Email</td>
        <td>{{ accessRequest.user.email }}</td>
      </tr>
      <tr v-if="downloadUrl && accessRequest.cv_url">
        <td class="property">Applicant CV</td>
        <td><a :href="downloadUrl">Download CV</a></td>
      </tr>
    </table>
    <h3 class="datasets-label">Datasets:</h3>
    <table class="datasets-table">
      <tr>
        <th>Dataset</th>
        <th>Access Type</th>
        <th>Host Location</th>
        <th>Visit Dates</th>
        <th v-if="accessRequestYear && accessRequestYear < 2024">
          Foreseen Reimbursement
        </th>
      </tr>
      <tr v-for="dataset in accessRequest.datasets" :key="dataset.id">
        <td>
          {{ dataset.dataset.label }}
          {{ dataset.is_main === 1 ? '(Main)' : '' }}
        </td>
        <td>{{ dataset.access_type }}</td>
        <td>
          {{ dataset.access_type === 'physical' ? dataset.host_location : '-' }}
        </td>
        <td>
          {{
            dataset.access_type === 'physical'
              ? dataset.preferred_visit_dates
              : '-'
          }}
        </td>
        <td v-if="accessRequestYear && accessRequestYear < 2024">
          {{
            dataset.access_type === 'physical' ? dataset.re_imbursement : '-'
          }}
        </td>
      </tr>
    </table>
  </div>
</template>

<script>
export default {
  props: {
    accessRequest: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      decodedToken: null,
      downloadUrl: '',
      accessRequestYear: null,
    };
  },
  mounted() {
    function parseJwt(token) {
      return JSON.parse(Buffer.from(token.split('.')[1], 'base64').toString());
    }
    const token = this.$auth.strategy.token.get().split(' ');
    this.decodedToken = parseJwt(token[1]);
    const date = new Date(this.accessRequest.created_at);
    this.accessRequestYear = date.getFullYear();
    this.downloadUrl = `${this.$config.apiRoot}/access_requests/${this.accessRequest.id}/cv?access_token=${token[1]}`;
  },
};
</script>

<style scoped>
.project-details-container {
  padding: 15px;
  margin-left: 10px;
  width: 98.5%;
}

.datasets-table {
  width: 100%;
}

.property {
  font-weight: bold;
}

.datasets-label {
  margin-top: 10px;
}

table td {
  padding: 5px;
}

.card {
  word-break: break-word;
  -webkit-hyphens: auto;
  -moz-hyphens: auto;
  -ms-hyphens: auto;
  hyphens: auto;
}

.revise-message {
  padding: 10px;
  background-color: #ffc150;
  border-radius: 5px;
  margin-bottom: 5px;
}
</style>
